# Base CI stage definitions for different use cases

stages:
  - !reference [ .base-stage:build, stage ]
  - !reference [ .base-stage:test, stage ]
  - !reference [ .base-stage:ci-work, stage ]
  - !reference [ .base-stage:lint, stage ]
  - !reference [ .base-stage:cleanup, stage ]
  - !reference [ .base-stage:release, stage ]
  - !reference [ .base-stage:publish, stage ]


# Stage Ruleset Mixins
#---------------------

'.stage-ruleset:only-on-merge-event':
  rules:
    - if: $CI_PIPELINE_SOURCE == 'merge_request_event'
      when: manual
      allow_failure: true

'.stage-ruleset:only-on-tags':
  rules:
    - if: $CI_COMMIT_TAG
      when: manual

'.stage-ruleset:scheduled':
  rules:
    - if: $CI_PIPELINE_SOURCE == "schedule"

'.stage-ruleset:only-on-trunk-commits':
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: manual


# Base Stage Definitions
#-----------------------

'.base-stage:prototype':
  # Prototype stage extended by most other stages
  script:
    # This only runs if no other scripts are run by the jobs that extend this prototype
    - echo "Running job '${CI_JOB_NAME}' with an empty script."

'.base-stage:ci-work':
  # Have the CI runner perform work that doesn't involve things like
  # building or testing an application
  stage: 'CI Work'
  extends:
    - .base-stage:prototype
  interruptible: true

'.base-stage:build':
  # Perform build steps required to ship projects using any platform
  stage: 'Build'
  extends:
    - .base-stage:prototype
  interruptible: true

'.base-stage:test':
  # Run test suites
  stage: 'Test'
  extends:
    - .base-stage:prototype
  interruptible: true

'.base-stage:lint':
  # Run linters to analyze code for problems with function and style
  stage: 'Lint'
  extends:
    - .base-stage:prototype
  interruptible: true

'.base-stage:cleanup':
  # Perform any chores required to ship
  stage: 'Cleanup'
  extends:
    - .base-stage:prototype
    - .stage-ruleset:only-on-trunk-commits

'.base-stage:release':
  # Cut a new tag and release for a project/package
  stage: 'Release'
  extends:
    - .base-stage:prototype
    - .stage-ruleset:only-on-trunk-commits

'.base-stage:publish':
  # Publish code to a target package/container registry or another target
  stage: 'Publish'
  extends:
    - .base-stage:prototype
    - .stage-ruleset:only-on-trunk-commits
